/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.basic.utilities.Integration;

import org.visnow.jscic.CellSet;
import org.visnow.jscic.IrregularField;

/**
 *
 * @author Krzysztof S. Nowinski, University of Warsaw, ICM
 */
public class IntegrationPanel extends javax.swing.JPanel
{

    private IrregularField inField = null;
    private static final String[] cellSetsTableHeader
        = new String[]{"cell set", "area", "volume"};
    private static final Class[] tableTypes
        = new Class[]{String.class, String.class, String.class};

    /**
     * Creates new form FieldStatsPanel
     */
    public IntegrationPanel()
    {
        initComponents();
        cellSetsTable.getColumnModel().getColumn(1).setPreferredWidth(52);
        cellSetsTable.getColumnModel().getColumn(2).setPreferredWidth(52);
    }

    void setField(IrregularField inField)
    {
        this.inField = inField;
        Object[][] entries = new Object[inField.getNCellSets()][3];
        for (int i = 0; i < entries.length; i++) {
            CellSet cs = inField.getCellSet(i);
            entries[i][0] = cs.getName();
            entries[i][1] = String.format("%6f", cs.getMeasure(2, inField.getCurrentCoords()));
            entries[i][2] = String.format("%6f", cs.getMeasure(3, inField.getCurrentCoords()));
        }
        cellSetsTable.setModel(new javax.swing.table.DefaultTableModel(
            entries, cellSetsTableHeader)
            {
                public Class getColumnClass(int columnIndex)
                {
                    return tableTypes[columnIndex];
                }
            });
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        displayButton = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        cellSetsTable = new javax.swing.JTable();

        setMinimumSize(new java.awt.Dimension(180, 550));
        setPreferredSize(new java.awt.Dimension(200, 600));
        setLayout(new java.awt.GridBagLayout());

        displayButton.setText("display full results");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(displayButton, gridBagConstraints);

        cellSetsTable.setModel(new javax.swing.table.DefaultTableModel(
                new Object[][] {

                },
                new String[] {
                        "cell set name", "area", "volume"
                }
                ) {
                    Class[] types = new Class[] {
                            java.lang.String.class, java.lang.String.class, java.lang.String.class
                    };
                    boolean[] canEdit = new boolean[] {
                            false, false, false
                    };

                    public Class getColumnClass(int columnIndex) {
                        return types[columnIndex];
                    }

                    public boolean isCellEditable(int rowIndex, int columnIndex) {
                        return canEdit[columnIndex];
                    }
                });
        jScrollPane1.setViewportView(cellSetsTable);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        add(jScrollPane1, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTable cellSetsTable;
    private javax.swing.JButton displayButton;
    private javax.swing.JScrollPane jScrollPane1;
    // End of variables declaration//GEN-END:variables

}
